/*******************************************************************************
 * FoxItemCacheInventory generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemCacheInventory extends FoxItemCacheBase
    native
    config(Game);

var const config int DefaultInventoryItemCap;
var private transient array<InventoryMetaData> CachedInventoryItems;
var private transient array<InventoryMetaData> CachedInventoryItemsBeforeUpdate;
var private transient array<InventoryMetaData> MergedInventoryItems;
var private transient array<InventoryMetaData> UpdatedInventoryItems;
var private transient int CachedInventoryItemCap;
var private transient bool bIsRefreshing;

function Initialize(UniqueNetId NetId)
{
    CachedInventoryItemCap = DefaultInventoryItemCap;
    super.Initialize(NetId);
    //return;    
}

function Cleanup()
{
    super.Cleanup();
    CachedInventoryItemCap = 0;
    CachedInventoryItems.Length = 0;
    CachedInventoryItemsBeforeUpdate.Length = 0;
    UpdatedInventoryItems.Length = 0;
    bIsRefreshing = false;
    //return;    
}

function SetupDelegates()
{
    // End:0x97
    if(NotEqual_InterfaceInterface(StoreInterface, (none)) && !bInitialized)
    {
        StoreInterface.AddQueryInventoryCompleteDelegate(0, ReadInventoryComplete);
        StoreInterface.AddInventoryUpdatedDelegate(0, InventoryUpdated);
    }
    //return;    
}

function CleanupDelegates()
{
    // End:0x95
    if(NotEqual_InterfaceInterface(StoreInterface, (none)) && bInitialized)
    {
        StoreInterface.ClearQueryInventoryCompleteDelegate(0, ReadInventoryComplete);
        StoreInterface.ClearInventoryUpdatedDelegate(0, InventoryUpdated);
    }
    //return;    
}

event bool GetCachedItemByGuid(out InventoryMetaData InventoryItem, string InstanceId, optional out FoxTypes.EPurchaseState PurchaseState)
{
    local int ItemIndex;

    // End:0xBA
    if(!bIsRefreshing && !IsDirty())
    {
        ItemIndex = CachedInventoryItems.Find('InstanceId', InstanceId);
        PurchaseState = 0;
        // End:0xB8
        if(ItemIndex != -1)
        {
            InventoryItem = CachedInventoryItems[ItemIndex];
            PurchaseState = class'FoxInventoryMetaData'.static.GetPurchaseState(InventoryItem);
        }
        return true;
    }
    return false;
    //return ReturnValue;    
}

// Export UFoxItemCacheInventory::execGetCachedItemByStoreItem(FFrame&, void* const)
native function bool GetCachedItemByStoreItem(out InventoryMetaData InventoryItem, StoreMetaData StoreItem, int AssociatedUnlockID, optional out FoxTypes.EPurchaseState PurchaseState);

// Export UFoxItemCacheInventory::execGetCachedItemByItemId(FFrame&, void* const)
native function bool GetCachedItemByItemId(out InventoryMetaData InventoryItem, int ItemId, int AssociatedUnlockID, optional out FoxTypes.EPurchaseState PurchaseState);

// Export UFoxItemCacheInventory::execGetCachedItemWithBestPurchaseState(FFrame&, void* const)
native function bool GetCachedItemWithBestPurchaseState(out InventoryMetaData InventoryItem, int UnlockID, optional out FoxTypes.EPurchaseState BestPurchaseState, optional int StartIndex, optional int AssociatedUnlockID)
{
    AssociatedUnlockID = 0;                            
}

// Export UFoxItemCacheInventory::execGetCachedItems(FFrame&, void* const)
native function bool GetCachedItems(out array<InventoryMetaData> InventoryItems, optional int UnlockID, optional FoxTypes.EPurchaseState PurchaseState, const optional array<FoxTypes.EFoxUnlockType> IncludedUnlockTypes, const optional array<string> FilterGuids, optional int AssociatedUnlockID)
{
    UnlockID = 0;
    PurchaseState = 0;        
    AssociatedUnlockID = 0;                                
}

// Export UFoxItemCacheInventory::execGetCachedItemsBeforeUpdate(FFrame&, void* const)
native function bool GetCachedItemsBeforeUpdate(out array<InventoryMetaData> InventoryItems, optional int UnlockID, optional FoxTypes.EPurchaseState PurchaseState, const optional array<FoxTypes.EFoxUnlockType> IncludedUnlockTypes, const optional array<string> FilterGuids, optional int AssociatedUnlockID)
{
    UnlockID = 0;
    PurchaseState = 0;        
    AssociatedUnlockID = 0;                                
}

// Export UFoxItemCacheInventory::execGetCachedItemCount(FFrame&, void* const)
native function bool GetCachedItemCount(out int InventoryCount);

// Export UFoxItemCacheInventory::execGetCachedItemCap(FFrame&, void* const)
native function bool GetCachedItemCap(out int InventoryCap);

protected function bool RefreshCache()
{
    // End:0x29
    if((IsDirty()) && !bIsRefreshing)
    {
        return ReadInventory();
    }
    return true;
    //return ReturnValue;    
}

private final function bool ReadInventory()
{
    bIsRefreshing = NotEqual_InterfaceInterface(StoreInterface, (none)) && StoreInterface.QueryInventory(OwnerNetId);
    // End:0x7C
    if(!bIsRefreshing)
    {
        ReadInventoryComplete(OwnerNetId, false, "");
    }
    return bIsRefreshing;
    //return ReturnValue;    
}

private final function ReadInventoryComplete(const UniqueNetId NetId, const bool bResult, string InventoryMeta)
{
    // End:0x9D
    if(IsOwner(NetId))
    {
        // End:0x91
        if(bResult)
        {
            CachedInventoryItems.Remove(0, CachedInventoryItems.Length);
            AddUpdateItems(NetId, InventoryMeta, CachedInventoryItemCap);
            CachedInventoryItemsBeforeUpdate = CachedInventoryItems;
            PurgeUpdatedItems();
            bIsDirty = false;
            NotifyPlayerInventoryLoadComplete();
        }
        bIsRefreshing = false;
    }
    //return;    
}

private final function InventoryUpdated(const UniqueNetId NetId, string ReadData)
{
    AddUpdateItems(NetId, ReadData);
    //return;    
}

private final function AddUpdateItems(const UniqueNetId NetId, string ReadData, optional out int ItemCap)
{
    local array<InventoryMetaData> UpdatedItems;
    local int I;

    // End:0xAE
    if(IsOwner(NetId))
    {
        UpdatedItems = class'FoxInventoryMetaData'.static.ParseFromXML(ReadData, ItemCap);
        I = 0;
        J0x5D:
        // End:0xA3 [Loop If]
        if(I < UpdatedItems.Length)
        {
            UpdatedInventoryItems.AddItem(UpdatedItems[I]);
            ++ I;
            // [Loop Continue]
            goto J0x5D;
        }
        MergeUpdatedItems(false);
    }
    //return;    
}

// Export UFoxItemCacheInventory::execHasUpdatedItems(FFrame&, void* const)
native function bool HasUpdatedItems(optional out array<InventoryMetaData> OutItems, optional string InstanceId, optional bool bFilterRemoved, optional bool bGeneratedByReferenceId);

function bool HasExpiredItems(optional out array<InventoryMetaData> OutItems)
{
    local array<int> ExpiredItemIndices;
    local int I;

    ExpiredItemIndices = GetExpiredItems();
    I = 0;
    J0x20:
    // End:0x70 [Loop If]
    if(I < ExpiredItemIndices.Length)
    {
        OutItems.AddItem(CachedInventoryItems[ExpiredItemIndices[I]]);
        ++ I;
        // [Loop Continue]
        goto J0x20;
    }
    return OutItems.Length > 0;
    //return ReturnValue;    
}

// Export UFoxItemCacheInventory::execMergeUpdatedItems(FFrame&, void* const)
native function MergeUpdatedItems(optional bool bPurge)
{
    bPurge = true;            
}

// Export UFoxItemCacheInventory::execPurgeUpdatedItems(FFrame&, void* const)
private native final function PurgeUpdatedItems();

function SynchronizeCachedInventoryItemsBeforeUpdate()
{
    CachedInventoryItemsBeforeUpdate = CachedInventoryItems;
    //return;    
}

// Export UFoxItemCacheInventory::execGetExpiredItems(FFrame&, void* const)
private native final function array<int> GetExpiredItems();

event bool OwnsWeaponLicense()
{
    local array<InventoryMetaData> Licenses;

    GetCachedItems(Licenses, class'FoxItemPurchaseDialogBox'.default.WeaponLicenseUnlockID, 4);
    // End:0x48
    if(Licenses.Length > 0)
    {
        return true;
    }
    return false;
    //return ReturnValue;    
}

event bool OwnsGPDoubler()
{
    local array<InventoryMetaData> GPDoublers;

    GetCachedItems(GPDoublers, class'FoxItemPurchaseDialogBox'.default.GPDoublerUnlockID, 4);
    // End:0x48
    if(GPDoublers.Length > 0)
    {
        return true;
    }
    return false;
    //return ReturnValue;    
}

// Export UFoxItemCacheInventory::execNotifyPlayerInventoryLoadComplete(FFrame&, void* const)
private native final function NotifyPlayerInventoryLoadComplete();

defaultproperties
{
    DefaultInventoryItemCap=1000
}